//+------------------------------------------------------------------+
//|                                                SQ_TTM Squeeze.mq4|
//|                            Copyright © @2021 StrategyQuant s.r.o.|
//|                                     http://www.strategyquant.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright © @2021 StrategyQuant s.r.o."
#property  link      "http://www.strategyquant.com"

//---- indicator settings
#property  indicator_separate_window;
#property  indicator_buffers 4
#property  indicator_color2  Red
#property  indicator_width1  1
#property indicator_color3 Magenta
#property indicator_color4 Aqua
//----
extern int BBPeriod=20;
extern int KCPeriod=20;
extern int LinRegPeriod=20;
extern int MomPeriod=20;
extern double BBDeviation=2;
extern double NumATRs=2;

//---- buffers
double SqueezeBuffer[];
double SqueezeMomentumBuffer[];
double SqueezeBufferUP[];
double SqueezeBufferDN[];

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexStyle(4,DRAW_ARROW);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   SetIndexBuffer(0,SqueezeBuffer);
   SetIndexBuffer(1,SqueezeMomentumBuffer);
   SetIndexBuffer(2,SqueezeBufferUP);
   SetIndexBuffer(3,SqueezeBufferDN);
   IndicatorShortName("SqTTMSqueeze("+BBPeriod+","+KCPeriod+","+LinRegPeriod+","+MomPeriod+","+BBDeviation+","+NumATRs+")");
   int startDraw = MathMax(BBPeriod,(MathMax(KCPeriod,MathMax(LinRegPeriod,MathMax(MomPeriod,MathMax(BBDeviation,NumATRs))))));
   SetIndexDrawBegin(0, startDraw);
   SetIndexDrawBegin(1, startDraw);
   SetIndexDrawBegin(2, startDraw);
   SetIndexDrawBegin(3, startDraw);

   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit; i>=0; i--)
     {
      int count =0;
      
      double linReg = iCustom(NULL, 0, "SqLinReg",LinRegPeriod,PRICE_CLOSE,0, i);
      double bbUpper = sqBands(NULL,0, BBPeriod, BBDeviation, 0, PRICE_CLOSE, 0, i);
      double bbLower = sqBands(NULL,0, BBPeriod, BBDeviation, 0, PRICE_CLOSE, 1, i);
      double kcUpper = iCustom(NULL, 0, "SqKeltnerChannel", KCPeriod, NumATRs, 0, i);
      double kcLower = iCustom(NULL, 0, "SqKeltnerChannel", KCPeriod, NumATRs, 1, i);
      double lrMomValue = iCustom(NULL, 0, "SqLinReg",LinRegPeriod,PRICE_CLOSE,0, i)-iCustom(NULL, 0, "SqLinReg",LinRegPeriod,PRICE_CLOSE,0, i+MomPeriod);
      
      if(bbUpper<=kcUpper&bbLower>=kcLower) {
      
         SqueezeBuffer[i] =1;
         SqueezeBufferUP[i] = 0;
      }
      else{
         SqueezeBuffer[i] =0;
         SqueezeBufferDN[i] = 0;
      
      }
      
         SqueezeMomentumBuffer[i] =lrMomValue;
       
     }
    
   return(0);
  }


double sqBands(string symbol, int timeframe, int period, double deviation, int bands_shift, int applied_price, int mode, int shift) {
   return roundValue(iBands(symbol, timeframe, period, deviation, bands_shift, applied_price, mode+1, shift));
}
double sqMTKeltnerChannel(string symbol, int timeframe, int period, double Deviation, int line, int shift) {
   return roundValue(iCustom(symbol, timeframe, "SqMTKeltnerChannel", period, Deviation, line, shift));
}

double roundValue(double value){
    return NormalizeDouble(value + 0.0000000001, 6);
}



